#version 300 es

precision mediump float;

in vec2 v_texCoords;
uniform sampler2D u_texture;
uniform float u_time;
out vec4 fragColor;

void main() {
    float tile_factor = 1.0;
    float aspect_ratio = 1.0;

    vec2 time_factor = vec2(2.0, 3.0);
    vec2 offset_factor = vec2(5.0, 2.0);
    vec2 amplitude = vec2(0.005, 0.005);

    vec2 tiled_uvs = v_texCoords * tile_factor;
    tiled_uvs.y *= aspect_ratio;

    vec2 wave_uv_offset = vec2(0.0, 0.0);
    wave_uv_offset.x += sin(u_time * time_factor.x + (tiled_uvs.x + tiled_uvs.y) * offset_factor.x);
    wave_uv_offset.y += cos(u_time * time_factor.y + (tiled_uvs.x + tiled_uvs.y) * offset_factor.y);

    fragColor = texture(u_texture, tiled_uvs + wave_uv_offset * amplitude);
}